<?php
class facteurs_prem{
 var $N; // le nombre à analyser
 var $tabprem=array(2,3,5,7);// table des premiers
 var $tabfac=array();
 var $chaine;
 
 function facteurs_prem($N){
     $this->N=$N;
     $this->fait_facts();
     $this->fait_chaine();
     return $this;
 }
 function exposant($i){
   $j=$i+1; $e=1;
   if(!isset($this->tabfac[$j])){
      $this->chaine.='.<br>';
      return $e;
   }
   if($this->tabfac[$i]!=$this->tabfac[$j]){
    $this->chaine.=' ';
    return $e;
  }
  $flag=true;
   while ($flag){
      $flag=$this->tabfac[$i]==$this->tabfac[$j];
      if($flag){
        $e++;
         $j++;
        $flag=isset($this->tabfac[$j]); 
       }
   }   
   if($e > 1)$this->chaine.='<sup>'.$e.'</sup> ';
   return $e;
 }
 function fait_chaine(){
   $this->chaine = 'Le nombre '.$this->N;
   $t= sizeof($this->tabfac);
   if($t==2)$this->chaine.= ' est le '.sizeof($this->tabprem).'<sup>e</sup> premier.<br>';
   else{
    $this->chaine.=' est égal à 1 ';
    $i=1;
    while($i < $t){
      $this->chaine.= ' x ';
      $this->chaine.= $this->tabfac[$i];
      $i+=$this->exposant($i);
    }
   }
 }
 ///////////////////////////
 function nouveau_prem($ip){
    $s=$ip+1; $a=2;
    while($this->est_divisible($this->tabprem[$ip]+$a))$a+=2;
    $this->tabprem[$s]=$this->tabprem[$ip]+$a;
 }
 function fait_facts(){
    $this->tabfac[0]=1;
    $limite=$this->N;
    $produit=1;
    $ip=0; // indice pour les premiers
    $i=1; 
    while($this->tabprem[$ip] <= $limite){
       while($limite % $this->tabprem[$ip] == 0){
          $this->tabfac[$i]=$this->tabprem[$ip];
          $produit *= $this->tabprem[$ip];
          $limite=$limite/$this->tabprem[$ip];
          $i++; 
       }
       if($ip >=3){
         $s=$ip+1; $a=2;
         while($this->est_divisible($this->tabprem[$ip]+$a))$a+=2;
         $this->tabprem[$s]=$this->tabprem[$ip]+$a;
       }
      // echo "produit : ".$produit." ".$limite.chr(10);
       $ip++;
    }
    //echo "tabfac 2".chr(10);
//    print_r($this->tabfac);
 }
 function est_divisible($n){
   $flag=false; $i=0;
   foreach($this->tabprem as $v){
      $flag= $n % $v ==0;
      if($flag)break;
   }
   return  $flag; 
 }
}
?>
