<?php
class nb_figadd{
  var $ordre = null; 
  var $rang = null;
  var $type="";
  
  function  nb_figadd(){ return $this;}

  function triangle_suivant($T,$r){return($T+$r);}
  function pyramide_suivante($P,$T){return $P+ $T;}
  function dble_pyramide_suivante($PA,$PP){return $PA+ $PP;}
  function prisme_suivant($PA,$TA,$TP){ return $PA+ $TA + ($TP * 2);} // le gnomon est le polygonal d'ordre 5 
  function reguli_suivant($RA,$TP,$r){
     $rp=$r-1; 
     $gnomon=(5*((3*$TP)-$rp))+1;
     return $RA+$gnomon;
  }
  // analyse
  function est_de_type($N,$r,$act,$pre,$type){
    $f= false; $o = 0;
	  if($N == $act)$f=true;
    if($pre > 0){
	  $f=($N-$act)% $pre == 0;
	  $o= ($N-$act)/$pre;
    }
	  if($f)$this->affecte($r,$o,$type);
	  return ($f ? 1 : 0);
  }
    // figures à deux dimensions
  function est_rectangle($N,$r,$ta,$tp){
    $ra=$ta*2;
    $rp=$tp*2;
    return $this->est_de_type($N,$r,$ra,$rp,'rectangle');
  }
  function est_polygonal($N,$r,$ta,$tp){
    $f=$this->est_de_type($N,$r,$ta,$tp,'polygone');
	return $f;
  }
  ////////////// nombres à 3 dimensions /////////////////
  function est_pyramide($N,$r,$pa,$pp){
    $f= $this->est_de_type($N,$r,$pa,$pp,'pyramide');
    return($f);
  }
  function est_dble_pyramide($N,$r,$dpa,$dpp){
    $f= $this->est_de_type($N,$r,$dpa,$dpp,'double pyramide');
    return($f);
  }
  function est_prisme($N,$r,$pra,$tp){
    $f= $N == $pra;
    $o=0;
    $dt= $r*$tp;
    $f= $this->est_de_type($N,$r,$pra,$dt,'prisme');
    return $f;
 }
  // est régulier
  function est_regulier($N,$r,$rga,$Ta){
    $dt=$r*2*$Ta;
    $f= $this->est_de_type($N,$r,$rga,$dt,'régulier/semi régulier');
    return $f;
  } 
  // affectations et reset
  function affecte($r,$o,$type){
    $this->ordre = 3 + $o; 
    $this->rang = $r;
    $this->type=$type;
  }
  

} // fin de classe
?>
