<?php
/* Les rectangles (éthéromèques et promèques ont des valeurs doubles de celles des polygonaux de même ordre et de même rang. 
  Cette sous classe calcule les rectangulaires d'ordre 3 et en communique la valeur pour chaque rang à la fonction remplit_rang définie dans la classe tablefig.
  Cette dernière remplit les rangs. Une fois la table pleine la sous classe appelle la fonction fait chaîne définie dans la classe table_rang*/
class rect_tab extends tablefig{
	function __construct($maxrang,$maxordre){
		parent::__construct($maxrang,$maxordre);
		$this->vr1=2;
		$this->diftab = $this->vr1;
		parent::base_table();
		$act=$this->diftab; // les rectangles de d'ordre 3 ou promèques sont le résultat de la sommation des nombtes pairs
		for($r=2;$r <= $this->maxrang; $r++){
			$act+=$r*2;
			parent::remplit_rang($act,$r);
		}
		parent::fait_chaine('Rectangles');
	}
}// fin de classe
?>