<?php
class nomb_analyse{
  var $nbana; //nombre à analyser
  var $TP=1;
  var $TA=0;// Triangle actuel
  var $PP=1;
  var $PA=0;// pyramide actuelle
  var $DPA=1; // double pyramides
  var $DPP=0;
  var $PRA=1; // prismes
  var $PRP=0;
  var $RGP=1; // réguliers et semi réguliers
  var $RGA=0;
  var $rang=2;
  var $index=0;
  var $formes=array();
  var $facts;
  var $diviseurs;
  var $chaine;
  var $fr2;
  var $fparf;
  var $divis;
  ///////////////////////////
  function  nomb_analyse($nbana){
      $this->nbana=$_POST['nba'];
      $this->fr2=isset($_POST['r2']);
      $this->fparf=isset($_POST['parf']);
      $this->divis= isset($_POST['diviseurs']);
      $this->analyse();
      $this->fait_chaine();
      $this->fact_prem();
  }
  ///////////////////////////////////////
  function fait_chaine(){
       $this->chaine='le nombre '.$this->nbana.' est :<br>';
       foreach($this->formes as $v){
          if($v->ordre==2){break;} 
          if($v->ordre == null)break;
          if(! $this->fr2 && $v->rang==2)continue;
          $this->chaine.=$v->type.' d\'ordre '.$v->ordre.' de rang '.$v->rang.'<br>';
       }
  }
  ///////////////////////////////////////
  function ajuste($m){
     if($m == $this->index)return $m;
     $this->formes[$this->index]= new nb_figadd();
     return $this->index;
  }
  function analyse(){
   $fin =  floor( sqrt($this->nbana*2) ); // racine entière
   $this->formes[$this->index]= new nb_figadd();
   while($this->rang <= $fin){
      $this->TA= $this->formes[$this->index]->triangle_suivant($this->TP,$this->rang);
      $this->PA= $this->formes[$this->index]->pyramide_suivante($this->PP,$this->TA);
      $this->DPA=$this->formes[$this->index]->dble_pyramide_suivante($this->PA,$this->PP);
      $this->PRA=$this->formes[$this->index]->prisme_suivant($this->PRA,$this->TA,$this->TP);
      $this->RGA=$this->formes[$this->index]->reguli_suivant($this->RGP,$this->TP,$this->rang);
      
      $m=$this->index;
      $this->index += $this->formes[$this->index]->est_rectangle($this->nbana,$this->rang,$this->TA,$this->TP);
      $m=$this->ajuste($m);
      $this->index += $this->formes[$this->index]->est_polygonal($this->nbana,$this->rang,$this->TA,$this->TP);
      $m=$this->ajuste($m);
      $this->index += $this->formes[$this->index]->est_pyramide($this->nbana,$this->rang,$this->PA,$this->PP);
      $m=$this->ajuste($m);
      $this->index += $this->formes[$this->index]->est_dble_pyramide($this->nbana,$this->rang,$this->DPA,$this->DPP);
      $m=$this->ajuste($m);
      $this->index += $this->formes[$this->index]->est_prisme($this->nbana,$this->rang,$this->PRA,$this->TP);
      $m=$this->ajuste($m);
      $this->index += $this->formes[$this->index]->est_regulier($this->nbana,$this->rang,$this->RGA,$this->TP);
      $m=$this->ajuste($m);
     ////// fin de boucle /////
      $this->TP= $this->TA;
      $this->PP= $this->PA;
      $this->DPP=$this->DPA;
      $this->PRP=$this->PRA;
      $this->RGP=$this->RGA;
      $this->rang ++;
 //     $this->index++;
   }
  // print_r($this->formes);
  }
  function fact_prem(){
     $this->facts = new facteurs_prem($this->nbana);
     $this->chaine.='<br>'.$this->facts->chaine;
	 $this->diviseurs = new diviseurs($this->nbana);
     if($this->divis)$this->chaine.= $this->diviseurs->chaine_diviseurs();
     if($this->fparf)$this->chaine.= $this->diviseurs->parfait();
  }
}
?>
