<?php
/* Les réguliers d'ordre 3 sont les icosaèdres et ceux d'otdre 5 les dodécaèdres. 
  Cette sous classe calcule les téguliers (ou semi réguliers) d'ordre 3 et en communique la valeur pour chaque rang à la fonction remplit_rang définie dans la classe tablefig.
  Cette dernière remplit les rangs. Une fois la table pleine la sous classe appelle la fonction fait chaîne définie dans la classe table_rang*/
class regu_tab extends tablefig{
	function __construct($maxrang,$maxordre){
		parent::__construct($maxrang,$maxordre);
		//$this->vr1=1;
		$this->diftab = $this->vr1;
		parent::base_table();
		$tp = $this->diftab; $act=$this->diftab; 
		for($r=2;$r <= $this->maxrang; $r++){
			$ta=$tp + $r;					//triangle actuel
			$this->diftab =2 * $tp * $r;	//modification de la variable diftab définie dans la classe tablefig 
			$act = 5*$r*($ta-$r)+$r;		//régulier actuel (icosaèdre)
			parent::remplit_rang($act,$r);
			$tp=$ta;
		}
		parent::fait_chaine('Réguliers ou semi réguliers');
	}
}// fin de classe
?>